package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.code.CmsWebAPICode;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.product.ItemService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.product.ItemDTO;
import cn.rankin.common.utils.dto.search.ItemSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.product.ItemVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/item")
public class ItemController {

    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<ItemVo>> search(@NeedUser UserDetails user, ItemSearchDTO searchDTO) {
        if (user == null) {
            return APIResult.error(CmsWebAPICode.ACCESS_DENIED);
        }
        if (!user.isPlatForm()) {
            searchDTO.setMerchantId(user.getMerchantId());
        }
        return itemService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<ItemVo> create(@RequestBody ItemDTO itemDTO) {
        return itemService.create(itemDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<ItemVo> udpate(@RequestBody ItemDTO itemDTO) {
        return itemService.update(itemDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {
        return itemService.delete(id);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<ItemVo> getItem(@PathVariable("id") String id) {
        return itemService.getItem(id);
    }

 }
