package cn.rankin.cmsweb.controller.user;

import cn.rankin.cmsweb.service.user.MerchantService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.user.MerchantDTO;
import cn.rankin.common.utils.dto.user.MerchantSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.user.MerchantVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

@RestController
@RequestMapping(value = "/merchant")
public class MerchantController {

    @Autowired
    private MerchantService merchantService;

    @RequestMapping(value = {"", "/list"}, method = RequestMethod.GET)
    public APIResult<Page<MerchantVo>> getPage(MerchantSearchDTO searchDTO) {
        return merchantService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<MerchantVo> create(@RequestBody @Valid MerchantDTO merchantDTO) {
        return merchantService.create(merchantDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<MerchantVo> update(@RequestBody @Valid MerchantDTO merchantDTO) {
        return merchantService.update(merchantDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable String id) {
        return merchantService.delete(id);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<MerchantVo> getMerchant(@PathVariable String id) {
        return merchantService.getMerchant(id);
    }

}
