package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.product.ItemDTO;
import cn.rankin.common.utils.vo.product.ItemVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface ItemService {

    @RequestMapping(value = "/item/list", method = RequestMethod.GET)
    APIResult<Page<ItemVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/item", method = RequestMethod.POST)
    APIResult<ItemVo> create(@RequestBody ItemDTO itemDTO);

    @RequestMapping(value = "/item", method = RequestMethod.PUT)
    APIResult<ItemVo> update(@RequestBody ItemDTO itemDTO);

    @RequestMapping(value = "/item/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/item/{id}", method = RequestMethod.GET)
    APIResult<ItemVo> getItem(@PathVariable("id") String id);
}
