package cn.rankin.productservice.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "lj_package_item_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"package_id", "item_id"})})
@DynamicInsert
@DynamicUpdate
public class PackageItemRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "package_id")
    private String packageId;

    @Column(name = "item_id")
    private String itemId;

    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_modified")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Column(name = "gmt_created")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
