package cn.rankin.productservice.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "lj_support_self_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"fid", "tid"})},
        indexes = {@Index(columnList = "fid"), @Index(columnList = "tid")})
@DynamicInsert
@DynamicUpdate
public class SupportSelfRelation implements Serializable {

    @Id
    private String id;

    @Column
    private String fid;

    @Column
    private String tid;

    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", insertable = false, updatable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
