package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.productservice.entity.Ware;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface WareRepository extends BasicJpaRepository<Ware, String> {

    Long countByCode(String code);

    Long countByIdIn(List<String> Ids);

    @Query(value = "update Ware w set w.status = :status  where w.id = :id")
    Integer deleteAllById(@Param("id") String id, @Param("status") BaseStatusEnum status);

    @Query(value = "select w from Ware w where w.id in (:ids) and w.status = :status")
    List<Ware> findByIdIn(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);

}
