package cn.rankin.userservice.entity;

import cn.rankin.common.utils.util.ProvinceUtil;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "campus")
@DynamicInsert
@DynamicUpdate
public class Campus implements Serializable {

    @Id
    private String id;

    @Column(name = "merchant_id")
    private String merchantId;

    @Column(name = "province_code")
    private String provinceCode;

    @Column(name = "city_name")
    private String cityName;

    @Column(name = "zone_name")
    private String zoneName;

    private Integer serialNo;

    @Column(name = "contact_name", nullable = false)
    private String contactName;

    @Column(nullable = false)
    private String mobile;

    private String address;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Transient
    private String name;

    @Transient
    private String merchantName;

    public String getName() {
        String pName = ProvinceUtil.get(provinceCode);
        if (pName != null) {
            return String.format("%s-%s-%s", pName, cityName, zoneName);
        }
        return null;
    }

}
